//TeXworksScript
//Title: xcolor Insert svgnames x11names usernames Dialogue 005
//Description: Colour dialog Interface version 005
//Author: Paul A. Norman
//Version: 0.4
//Date: 2011-04-17
//Script-Type: standalone
//Context: TeXDocument
//Shortcut: Alt+X, Alt+C

// X C for xcolor package by Dr. Uwe Kern xcolor@ukern.de

// Many thanks to Stefan Loffler for answering many questions - thanks :)

//  initialise

// eval(TW.app.getGlobal("helper_twPan")); //  Comment if NOT Needed - This includes PhpJs ($P), twConst, msgBox, twPan ($tw), string.toTitleCase()

// Not using gloabl object(s) above:, for initial public release  - just pulling out some bits here:

  const twConst = {
           SystemAccess_NotAttempted : -1,
                     SystemAccess_OK : 0,
                 SystemAccess_Failed : 1,
       SystemAccess_PermissionDenied : 2

              }; // end twConst

// downsized version of twPan gloable her for public relase of this script

twPan = {

//%:     ##file_get_contents## : string; 

file_get_contents : function(){


                 if (this.file_get_contents.arguments.length == 0)
                       {
                       fileNameFullPath = TW.app.getOpenFileName(); 
                       }
                     else
                       {
                        fileNameFullPath = this.file_get_contents.arguments[0];
                        }

                               var res = TW.readFile(fileNameFullPath);
                                 switch (res.status)
                                 {
                                   case twConst.SystemAccess_PermissionDenied:
                                   case twConst.SystemAccess_Failed:
  												 this.alert(res.message);
												var text = undefined;
											break;

                                   case twConst.SystemAccess_OK:  												 
												var text = res.result;
											break;
                                  }

                                return text;
         
                                               }, // End. twPan.file_get_contents
                                               
//%:     file_put_contents : void;

         file_put_contents : function(fileNameFullPath , fileContents){
                                 var  status = TW.writeFile(fileNameFullPath, fileContents); // pathFileName, Contents (- utf-8) 
                                 switch (status)
                                 {
                                   case twConst.SystemAccess_PermissionDenied:
                                   case twConst.SystemAccess_Failed:
  									 this.alert('Please Turn on File Writing in \n\ Edit Menu / Preferences / Scripts');
											break;

                                 } // End. switch (status)
 
 
         
                                             } // End. twPan.file_put_contents                                               
                         
} // end twPan


var   editDocument = TW.target;
if(!editDocument.save())
{
       TW.warning(null, "Need to Save First", "Please Save before using Colour Dialogue");
          throw Error("The TeX file must be saved before running this script");
    // Thanks Stefan for this point
}

var RGBvalue = new Array(); // used in  sliderMoved(), newfromNamedColour()
var initialSlideTogetherValue = 0;
var chosenColour = "";
var rgbNames = ["Red","Green","Blue"];
var cmykNames =["cyan", "magenta", "yellow", "black"];
var colourTables = ["colourTable_svgnames", "colourTable_X11names", "colourTable_gray"];
var currentColour = {tableName : "",  intRow : -1, intCol : -1};
var previouslySetColours = __FILE__.replace(".js","_previouslySetColours.html");

function colourData()
{
    this.name = "" ;
    this.colours = {red : "", green : "", blue : "" };
    var that = this;
    this.formRgb = function(){
               return "rgb(" + that.colours.red +", " + that.colours.green +", " + that.colours.blue + ")";
                 };
}
colourProperties = new colourData();

var selectedText = editDocument.selection;
var xmlUI ;
            getUiXml();  // this must be obtained for later use before creating the user interface
var sliderMovedByScript = false;
var slideTogetherLastPos = 0;

var colourDialogue = TW.createUI(__FILE__.replace(".js",".ui"));
var dialogueChildObjects = colourDialogue.findChildren();

/*All wanted widgets (rather than all - resource overheads) could be seemlessly added by giving required wudgets an .objectName in the .ui that has a particualar suffix or prefix as part of their name e.g. _forScript  ...    blueButton_forScript

Then do something like ...

for (widget in dialogueChildObjects)
   {
     if(dialogueChildObjects[widget].objectName.indexOf("_scriptable") > -1)
       {scriptWidgets.push(dialogueChildObjects[widget].objectName);}
                                 //Pass the name not the object (it doesn't exist in script yet) and an
                                      array of names may be useful
   }

    for (widget in scriptWidgets)
  {
    eval( scriptWidgets[widget] + " = TW.findChildWidget(colourDialogue,\"" + scriptWidgets[widget] + "\")" );
   }

   You can then use widget by propertyMane in script:--

                  e.g.    blueButton_forScript.styleSheet = "background-color : blue; color : white";

   If you want to monitor events (slots)

   (Right click the widget in the .ui Designer to get possibly available slots
    Menu will show  "goto slot ..."  (.clicked is not always available)

    Add to function UIconnectVarious() -  below here ...

    (booleanAction)eval("nameofWidget.slotEvent." +  doThis(booleanAction)  + "(functionYouWriteBelow)");

    And write a QTScript function (  functionYouWriteBelow(){}   ) to handle the connection!
    Try putting sender in the function argument reciever functionYouWriteBelow(sender), and alert(sender) it in
    the function to see whether you get anything useful or not.

   I've done a long list of some widgets here, to make it easier for me to remember their names
   when I need them, and bulk-  processed others.
*/


// Add Qt widget names required for scripting and slot connecting here

var scriptWidgets =                                                                                                                      [
"tabColourTables",      "colourTextBox",             "btnClear",            "panelRgbColour",  "btnInsertEditor",
"btnInsertDirectEditor", "editProposedDefineColour", "editRgbRed",          "editRgbGreen",    "editRgbBlue",
"editRGBSpec",           "slideTogether",            "sliderRgbRed",        "sliderRgbGreen",  "sliderRgbBlue",
"lblYourNewColorName",   "editYourNewColorName",     "flow_NamedColours",   "editGrayAsBlack", "editGrayAsgray",
"scrollColourButtons",   "editCMYKmagenta",          "editCMYKyellow",      "editCMYKblack",   "updateRGBbinary",
"updateRGBtetras",      "updateRGBblackExclamation", "updateRGBGrayBinary", "sliderBlack",     "editHSBhue",
"editHSBsaturation",     "editHSBbrightness",        "updateHSBValues",     "editCMYKcyan",    "panelGray",
"resetMoveTogether",     "previouslySet",            "addPredefined",       "savedUse",        "savedEditName",
"savedDelete",           "user_radioHSV",            "holdColour",          "updateCMYKValue", "flow_DirectColour"


];

 var prev_colours = new Array();
            // the temporary hold colours buttons below main colour panel display widget "panelRgbColour"
 for (ii = 0; ii < 10; ii++)
        {
     eval("prev_0" + ii.toString() + " = TW.findChildWidget(colourDialogue,\"prev_0" + ii.toString() + "\")");
     eval("prev_colours.push(prev_0"+ii.toString()+")");
     // buttons are hard to deal with as, slots -> QtScript, do not tell us which one was clicked. so ..
     // we pass the script object to a genreic function via a function built in memory for each
     // of these buttons here.
     eval("function prev_0"+ii.toString()+"_clicked(){prevColour_clicked(prev_0"+ii.toString()+")}");
         }

      // process buttons for: tint, tone, shade, compliment
 var tintsEtc = new Array("colour_tint", "colour_tone", "colour_shade", "colour_compl");
  for (btn in tintsEtc)
 {
      eval( tintsEtc[btn] + " = TW.findChildWidget(colourDialogue,\""+ tintsEtc[btn] +"\")");
      // As for above, we pass the script button object to a genreic function in a function
      // built in memory for each of these buttons here
      eval("function " + tintsEtc[btn]+"_clicked(){setFromStyleSheet("+tintsEtc[btn]+")}");
  }

 var links_userDefineCommon = new Array();

  // find flow chart General and specific links and add them to scriptable widgets array and display control array(s) - saves a lot - a lot - of typing!
   for (widget in dialogueChildObjects)
   {
     if(dialogueChildObjects[widget].objectName.indexOf("link_") > -1)
       {scriptWidgets.push(dialogueChildObjects[widget].objectName);} //Pass the name not the object (it doesn't exist in script yet)
   }

    for (widget in scriptWidgets)
  {
    eval( scriptWidgets[widget] + " = TW.findChildWidget(colourDialogue,\"" + scriptWidgets[widget] + "\")" );
    }

    for (widget in dialogueChildObjects)
   {
     if(dialogueChildObjects[widget].objectName.indexOf("link_userDefineCommon") > -1)
       {links_userDefineCommon.push(dialogueChildObjects[widget]);} //Pass the object not the name
      }

/*  Access widget in script as in: (i)  editRgbRed.text = "something";
          All  functions and properties available to Script can be used in this manner.

    Hint:
          If a property exists, use it as in (i) above, rather than:  myWidget.setFunction("something");

    To assign a QtScript function here to a "slot" (event) in the .ui, add it To the function here
     following the general pattern shown in the comment below.
    Make sure you create that named fucntion further down hrere
     for the slot to connect to.
*/

function UIconnectVarious(booleanAction)
{
 /* This streamlines initialisation and finalisation of the script dialogue slot connections

      doThis(..) passes either true or false and returns either 'connect' or 'dissconect'

      eval("nameofWidget.slotEvent."       +  doThis(booleanAction)  + "(functionYouWriteBelow)");
                                                                     // !make function

      for buttons using generic handlers, functions used in iterations here
          have been virtually created in memeory (above here)
          below where var scriptWidgets is declared.
 */
 eval("btnClear.clicked."                  +  doThis(booleanAction)  + "(clearColourChoice)");
 eval("updateRGBbinary.clicked."           +  doThis(booleanAction)  + "(updateRGBfromBinary)");
 eval("updateRGBtetras.clicked."           +  doThis(booleanAction)  + "(updateRGBfromTetras)");
 eval("updateRGBblackExclamation.clicked." +  doThis(booleanAction)  + "(updateRGBfromBlack)");
 eval("updateRGBGrayBinary.clicked."       +  doThis(booleanAction)  + "(updateRGBfromGray)");
 eval("sliderBlack.valueChanged."          +  doThis(booleanAction)  + "(updateGrays)"); //
 eval("updateHSBValues.clicked."           +  doThis(booleanAction)  + "(updateRGBfromHSV)");
 eval("updateCMYKValue.clicked."           +  doThis(booleanAction)  + "(cmykToRgb)");
 eval("flow_NamedColours.clicked."         +  doThis(booleanAction)  + "(Action)");
 eval("resetMoveTogether.clicked."         +  doThis(booleanAction)  + "(resetMoveTogether_clicked)");
 eval("slideTogether.valueChanged."        +  doThis(booleanAction)  + "(slideTogether_changed)");
 eval("addPredefined.clicked."             +  doThis(booleanAction)  + "(addPredefined_clicked)");
 eval("previouslySet.anchorClicked."       +  doThis(booleanAction)  + "(previouslySet_anchorClicked)");
 //eval("editPredefined.clicked."          +  doThis(booleanAction)  + "(editPredefined_clicked)");
 eval("user_radioHSV.clicked."             +  doThis(booleanAction)  + "(user_radioHSV_clicked)");
 eval("holdColour.clicked."                +  doThis(booleanAction)  + "(holdColour_clicked)");
 eval("flow_DirectColour.clicked."                +  doThis(booleanAction)  + "(flow_DirectColour_clicked)");

 for (ii = 0; ii < 10; ii++)
        {   // previous colour buttons
        // function(s) (dis-)connected here, are created in script above in:  for (ii = 0; ii < 10; ii++)
         eval("prev_0"+ii.toString()+".clicked."+  doThis(booleanAction)  + "(prev_0"+ii.toString()+"_clicked)");
        }

 for (btn in tintsEtc)
       {
        // function(s) (dis-)connected here, are created in script above in earlier:  for (btn in tintsEtc)
         eval(tintsEtc[btn]+".clicked."+  doThis(booleanAction)  + "("+tintsEtc[btn]+"_clicked)");
       }

} // /End. function UIconnectVarious(booleanAction)


// /Begin

setup();

// colour Table links
// var links_svgnames = [link_svgnames, link_svgnames_cross];
// var links_X11names = [link_X11names, link_colourTables_down];
// var links_tblgray = [link_tblgray, link_gray_cross];
// var links_colourTable_common = [link_colourTables_down, link_colourName_cross];
var links_comboBox = [link_flowNamedColours_comboBox];
// var links_combobox_OK = [link_comboBox_cross, link_comboBox_down];
// var links_From_Direct = [link_flow_DirectColour];

// var allLinks_colourTable = [links_svgnames, links_X11names, links_tblgray, links_colourTable_common, links_comboBox, links_combobox_OK, links_From_Direct, link_flowNamedColours_comboBox];

var allLinks_colourTable = [ links_comboBox, link_flowNamedColours_comboBox];

function clearColourChoice()
 {
 colourTextBox.text = "";

   colourLinks([allLinks_colourTable],[[links_combobox_OK]], "rgb(0,0,0)");
 }

function flow_DirectColour_clicked()
{
// link_userDefineCommon_outOfUsertoCommand


}

run();
//alert("ok");

// clean up
     UIconnectColourTables(false);
     UIconnectVarious(false);
     UIconnectSliders(false);

// /End.

 ////////Functions\\\\\\\\

function holdColour_clicked()
{

   for (jj =  9; jj > 0; jj-- )
    {
       prev_colours[jj].styleSheet = prev_colours[jj -1].styleSheet;
     }
    prev_colours[0].styleSheet = panelRgbColour.styleSheet;
}


function prevColour_clicked(whichBtn)
{
setFromStyleSheet(whichBtn);
}

function user_radioHSV_clicked()
{

}

function setFromStyleSheet(thisWidget)
{
      prepare = thisWidget.styleSheet.toString();
      prepare = prepare.substr(prepare.indexOf('background-color'));

  findRgb_start = prepare.indexOf("(") + 1;
  findRgb_end = prepare.indexOf(")");

  prepare = prepare.substr(findRgb_start, findRgb_end - findRgb_start).split(",");

  sliderMovedByScript = true;
  setSlidersRGB(prepare[0], prepare[1], prepare[2])
}


function editPredefined_clicked()
{
    TW.app.clipboard = previouslySetColours;
    alert("Edit <span style=\"color:red\">Carefully</span> - Make A Backup<br><br>This Dialogue Will Close First.<br>Use Your favourite HTML Editor (Filename is on Clipboard).");
     colourDialogue.reject();
}

function previouslySet_anchorClicked(sender)
{
var performSave = false;

var url = sender.toString();
var  colourRequested = url.substr(url.lastIndexOf("/") +1).replace(".html","").split(",");

    if (savedUse.checked == true)
        { setSlidersRGB(colourRequested[1], colourRequested[2], colourRequested[3]) ;
        // Global
         sliderMovedByScript = true;
         editProposedDefineColour.text = colourRequested[0];
        }
      else
    {
      colourList = previouslySet.html.toString().split("\n");

      for (num in colourList)
           {
              if (colourList[num].indexOf(colourRequested.join(",")) > -1)
              {

              if (savedDelete.checked == true)
                {
                 if (TW.information( null, "Delete Colour", "Delete this Colour?", 0x00004000 | 0x00010000,0x00010000) == 0x00004000) // Yes
                  {
                     colourList[num] = "";
                         performSave = true;
                       }
                    }
                   else // savedEditName.checked == true
                   {
          newName = TW.getText(null, "Change Colour Name", "New Name" , colourRequested[0] );

             if (newName != null)
                 {

               eval("colourList[num] = colourList[num].toString().replace(/"+colourRequested[0]+"/g,\""+newName+"\")");
                   performSave = true;
                  }
                   }
               break;
                }
           }
            if  (performSave == true)
                 {
                   previouslySet.html = colourList.join("\n");
                   saveText(previouslySetColours, previouslySet.html );
                  }
        }
}


function addPredefined_clicked()
{ //Scripting doesn't support - reference http://lists.trolltech.com/qt-interest/2007-09/thread00176-0.html

    rgb = [editRgbRed.text, g = editRgbGreen.text, b = editRgbBlue.text] ;
rgbText = rgb.join(",");

colourName  = (editProposedDefineColour.text != "") ? editProposedDefineColour.text :
"Un-named " + rgbText.replace(/,/g," - ") + " ";
colourLink =  (editProposedDefineColour.text != "") ? editProposedDefineColour.text +"," + rgbText :
"Un-named " + rgbText.replace(/,/g," - ") + " " + "," + rgbText;

if (previouslySet.html.toString().indexOf(colourName) == -1) // add comma to find exact reperesetation not part name in href=""
{
  previouslySet.html += "<span title=\"hello\" style=\"color: rgb("+rgbText+"); background-color: rgb("+rgbText+")\">XXXXXXXXXXXXX</span><span style=\"background-color: white;\"> &nbsp; </span><a href=\"" + colourLink +"\"><span style=\"background-color: white;\">"+colourName+"</span></a>\n";
 saveText(previouslySetColours, previouslySet.html );
}
else
{
  alert(colourName + " is an already used Colour Name");
 }

}

function setup()
{
			 
showEditYourNewColorName(false);

 UIconnectSliders(true);

 UIconnectVarious(true);

 for (tabl in colourTables)
   {
        eval(colourTables[tabl] + ' = TW.findChildWidget(colourDialogue,\"'+ colourTables[tabl] +'\")');
     }

 UIconnectColourTables(true);

 colourLinks([], [[links_userDefineCommon]], "red");
//alert(previouslySetColours);
// alert(getText(previouslySetColours));

previouslySet.html = getText(previouslySetColours, true);

//  ="<div  style=\"background-color:rgb(255,0,0);\"><b><a href=myRed,255,0,0.html>myRed</a></b></div><div style=\"background-color:rgb(0,255,0);\"><b><a href=myGreen,0,255,0.html>myGreen</a></b></div>";


} //   /End. setup()


function run()
{

   retVal =  colourDialogue.exec();

switch(retVal )
 {
 case 1:

     chosenColour = colourTextBox.text;
          editDocument.statusTip = " Remember - \\usepackage[svgnames,x11names,named]{xcolor}";

      var  colourCommandCombBoxInDialogue = 	TW.findChildWidget(colourDialogue,"comboBox") ;
              commandText = colourCommandCombBoxInDialogue.currentText;

      switch(commandText)
            {
            case  "Just Insert Colour":

             if (chosenColour != "")
               {editDocument.insertText(chosenColour);}

                 break;

            default:

                 if(selectedText == null){selectedText = "Text Here";}

                 commandText = commandText.replace("colour",chosenColour);
                     commandText = commandText.replace("text here",selectedText);
                       editDocument.insertText(commandText);

                     editDocument.selectRange(editDocument.selectionStart - selectedText.length - 1,
                                         selectedText.length);

                  if (commandText.indexOf("back-color") > -1)
                  {editDocument.selectRange(editDocument.selectionStart - 12, 10);}

                   break;
            }// /End.  switch(commandText)

       break;	// /End. switch colourDialogue.exec() case 1:

 case 0:

        break;
 default:

        break;

}// /End. switch( colourDialogue.exec() )

}  // /End. run();


function showEditYourNewColorName(booleanShow)
{
            lblYourNewColorName.visible = booleanShow;
           editYourNewColorName.visible = booleanShow;
}

function getUiXml()
{
    designUi = __FILE__.replace(".js",".ui");

    xmlUI = getText(designUi);

}

function getText(thisFileName, Tw) // stand-in while no Tw function was yet available
{

 
  thisText="empty";

  if (Tw == true)
  {
    /*  gettingText = TW.app.openFile(thisFileName);
     thisText = gettingText.text;
     gettingText.close();
    
     */
    thisText = twPan.file_get_contents(thisFileName); 
     
       return thisText;
 }


  switch(TW.platform())
      {
       case "MacOSX":
         // Have this checked
         thisText =  twPan.file_get_contents(thisFileName); 
           break;

       case "Windows":
       /*  thisFileName=thisFileName.replace(/\//g , '\\');
         buildCommand= 'cmd /c type \"' + thisFileName + '\"';
         thisText =  TW.app.system(buildCommand);
       */
       
     thisText =  twPan.file_get_contents(thisFileName); 
           break;

       case  "X11":
          // Have this checked
         thisText =  twPan.file_get_contents(thisFileName); 
       break;

       case  "unknown":
        // what ever  is needed
       break;

       // probably no need for default: here
      } // /End. switch(TW.platform())

 // alert(thisText);
return thisText;
} // /End. function getText()

function saveText(thisFileName, thisText)
{ // Warning! this overwrites current contents

  // left over from when Tw had no built in script function for daveing a file contents

  /*savingText = TW.app.openFile(thisFileName);
   savingText.selectAll();
   savingText.insertText(thisText);

  response =  savingText.save();
     savingText.close();
  */
  
   twPan.file_put_contents(thisFileName, thisText);
   
   // return response;

} // /End. function saveText()

function updateGrays()
{
        blackValue = sliderBlack.value * 1;

        editGrayAsBlack.text = "Black!" + (100 - blackValue).toString() ;
        editGrayAsgray.text = (blackValue/100).toString().substr(0,7);


        rgbValueGray = Math.round(blackValue/100 * 255).toString();

        panelGray.styleSheet = "background-color: rgb(" + rgbValueGray +","
                                                                + rgbValueGray +","
                                                                + rgbValueGray
                                                            + ")";
}

function colourLinks(makeInactiveArrays, colourTheseArrays, colourLinkThis)
{

    // Clear curtrent colour form these link groups

   for (links in makeInactiveArrays)
    {
      for (thisLink in makeInactiveArrays[links])
       {
           for (link in makeInactiveArrays[links][thisLink])
          {
           makeInactiveArrays[links][thisLink][link].styleSheet = "color: white";
         makeInactiveArrays[links][thisLink][link].lineWidth= "1";
        }
      }
    }

   //Colour these links
for (links in colourTheseArrays)
    {
       for (thisLink in colourTheseArrays[links])
       {
           for (link in colourTheseArrays[links][thisLink])
           {
           colourTheseArrays[links][thisLink][link].styleSheet = "color: "+colourLinkThis;
         colourTheseArrays[links][thisLink][link].lineWidth= "2";
       }
     }
   }
}

function resetMoveTogether_clicked()
{

 //dis-connect slot/event monitoring
 eval("slideTogether.valueChanged."+  doThis(false)  + "(slideTogether_changed)");

 slideLow  =   Math.min(sliderRgbRed.value, sliderRgbGreen.value, sliderRgbBlue.value);
 slideHigh =   Math.max(sliderRgbRed.value, sliderRgbGreen.value, sliderRgbBlue.value);

 slideTogether.minimum = 0;
   slideTogether.maximum = (255 - slideHigh) + slideLow;

   slideTogether.sliderPosition = slideLow;
   slideTogetherLastPos = slideLow;

  //re-connect slot/event monitoring
eval("slideTogether.valueChanged."+  doThis(true)  + "(slideTogether_changed)");
}



function slideTogether_changed(howMuch)
{
    howMuchMoved = howMuch - slideTogetherLastPos;


         sliderRgbRed.sliderPosition += howMuchMoved;
        sliderRgbGreen.sliderPosition += howMuchMoved;
        sliderRgbBlue.sliderPosition += howMuchMoved;
sliderMovedByScript = true;
        slideTogetherLastPos = howMuch;
}

function sliderMoved(sliderRGBRed)
 {

    // Global sliderMovedByScript used here

 var xcolorRGBvalue ='';
   // Global RGBvalue Array();
 var rgbStd = "";
 var rgbCompliment = "";
 var GrayFromRgb = "";

    for ( col in rgbNames)
        {
            eval("if (( sliderRgb"+rgbNames[col]
                      +".focus == true) | (sliderMovedByScript == true)){editRgb"
                          + rgbNames[col]
                              + ".text = sliderRgb"
                                  +rgbNames[col] +".sliderPosition;}"
                );

        eval("RGBvalue["+ col +"] = editRgb" + rgbNames[col] + ".text; ");
	
            rgbStd += RGBvalue[col] +", ";
            rgbCompliment += (255 - (1*RGBvalue[col])) + ", ";

            xcolorRGBvalue += (RGBvalue[col]/255).toString().substr(0,7) + ", " ;
       }// /End. for ( col in rgbNames)
 
	editRGBSpec.text = xcolorRGBvalue.substr(0, xcolorRGBvalue.length - 2)	;

               panelRgbColour.styleSheet = "background-color: rgb("+ rgbStd.substr(0,rgbStd.length-2)  +");";


         newHSB = rgbToHsv(RGBvalue[0], RGBvalue[1], RGBvalue[2]) ;

                   editHSBhue.text = newHSB[0].toString().substr(0,7);
            editHSBsaturation.text = newHSB[1].toString().substr(0,7);
            editHSBbrightness.text = newHSB[2].toString().substr(0,7);

        GrayFromRgb = (0.3 * RGBvalue[0]/255) + (0.59 * RGBvalue[1]/255)  + (0.11 * RGBvalue[2]/255);
                                                                         // (45) Pg. 49 xcolor  Dr. Uwe Kern


var colorCompensate =  ( GrayFromRgb > 0.5) ? "color : white; " : "color : black; ";

colour_compl.styleSheet = colorCompensate + "background-color: rgb("+ rgbCompliment.substr(0,rgbCompliment.length-2)  +");";

                            // tint, shade, tone Pg.1 'Chroma a Reference book of LaTeX colors', Dr. Uwe Kern
var newTint = new Array(); var newShade = new Array(); var newTone = new Array();

for (x=0; x<3; x++)
{
 // tint    50% mixture with white 128,128,128
 newTint[x]  = Math.round(RGBvalue[x]/2) + 127; // adjustment

 // tone    50% mixture with gray 64,64,64
 newTone[x]  = Math.round(RGBvalue[x]/2) + 64;

 // shade   50% mixture with black 0,0,0,
 newShade[x] = Math.round(RGBvalue[x]/2);

} // /End. for (x in rgbValue)

colour_tint.styleSheet = "background-color: rgb(" + newTint.join(",")  + ");\n color: " + contrastText(newTint) + ";";
colour_tone.styleSheet = "background-color: rgb(" + newTone.join(",")  + ");\n color: " + contrastText(newTone) + ";";
colour_shade.styleSheet = "background-color: rgb(" + newShade.join(",") + ");\n color: " + contrastText(newShade) + ";";

        sliderBlack.value = Math.round(GrayFromRgb * 100);

        rgbValueGray = Math.round(GrayFromRgb * 255).toString();   // gray - E (86) Pg. 53 xcolor  Dr. Uwe Kern

        editGrayAsBlack.text = "Black!" + (100 -  Math.round(100 * GrayFromRgb)) ;
        editGrayAsgray.text = GrayFromRgb.toString().substr(0,7);

                panelGray.styleSheet = "background-color: rgb(" + rgbValueGray +","
                                                                + rgbValueGray +","
                                                                + rgbValueGray
                                                            + ")";

        /* after ... http://sci.tech-archive.net/Archive/sci.image.processing/2007-02/msg00120.html
           "A better formula is: ... "  (see notes at bottom of this .js - Paul)  */

R = RGBvalue[0]/255;
G = RGBvalue[1]/255;
B = RGBvalue[2]/255;

Ctemp = 1 - R;
Mtemp = 1 - G;
Ytemp = 1 - B;
Ktemp = Math.min(Ctemp, Mtemp, Ytemp);

cyan    = Math.min(1, Math.max(0, Ctemp-Ktemp));
magenta = Math.min(1, Math.max(0, Mtemp-Ktemp));
yellow  = Math.min(1, Math.max(0, Ytemp-Ktemp));
black   = Math.min(1, Math.max(0, Ktemp));

  for (cmyk in cmykNames)
{eval("editCMYK" + cmykNames[cmyk] + ".text = " + cmykNames[cmyk] + ".toString().substr(0,7)" );
 //TW.information(null, "test",eval(cmykNames[cmyk]) );
}



        // 	panelGray editGrayAsBlack  editGrayAs_gray

}// /End.  function sliderMoved(moved)


function  contrastText(rgbs)
{
  var grayFromRgb = (0.3 * rgbs[0]/255) + (0.59 * rgbs[1]/255)  + (0.11 * rgbs[2]/255);
                                                                         // (45) Pg. 49 xcolor  Dr. Uwe Kern
  var textColour = (grayFromRgb > 0.5) ? "black" : "white";
    return textColour;
}

function whichTable()
	{
    	inUse = tabColourTables.currentIndex;
  	return colourTables[inUse];
	}
		  
	
function handleColourTable(intRow,intCol)
 {  
    if (intCol == 4)
     {TW.warning(null,"This Column is Informational Only", "Please Choose A Coloured Area");
    }
        else
         { currentColour.tableName = whichTable();
           currentColour.intCol = intCol;
           currentColour.intRow = intRow;
            getCurrentColour();
           colourTextBox.text =  colourProperties.name;

         switch (tabColourTables.currentIndex)
         {
           case 0: // svgnames
            //   colourLinks([allLinks_colourTable], [[links_svgnames, links_colourTable_common]], colourProperties.formRgb());

               break;

           case 1: // x11names
           //   colourLinks([allLinks_colourTable], [[links_X11names, links_colourTable_common]], colourProperties.formRgb());

            break;

           case 2: // xcolor gray
            //  colourLinks([allLinks_colourTable], [[links_tblgray, links_colourTable_common]],colourProperties.formRgb());


             break;

          default:
             break;
         }
    //   colourLinks([],[[links_combobox_OK, links_comboBox]], colourProperties.formRgb());


     }
			
  } // /End. handleColourTable(intRow,intCol			
	
function newfromNamedColour()
 {
   // RGBvalue
	editProposedDefineColour.text =  "myNew" + colourTextBox.text;
        tabColourTables.currentIndex = 4;

        setSlidersRGB( colourProperties.colours.red, colourProperties.colours.green, colourProperties.colours.blue);
	
  }			

// Button Functions


function updateRGBfromBinary()
{
      rgbBinaries = editRGBSpec.text.split(",");
      // alert(rgbBinaries);
      setSlidersRGB(rgbBinaries[0],rgbBinaries[1],rgbBinaries[2]);
}

function updateRGBfromTetras()
{
    setSlidersRGB(editRgbRed.text, editRgbGreen.text, editRgbBlue.text);
}

function updateRGBfromGray()
{

   var grayRGB = editGrayAsgray.text * 255;

   setSlidersRGB(grayRGB, grayRGB, grayRGB );
}

function updateRGBfromBlack()
{
var doMessage = false;

 if (isNaN(editGrayAsBlack.text * 1) == true)
      {numStart = editGrayAsBlack.text.indexOf("!") +1 ;}
   else
 {numStart = 0;}

   if (numStart < 0)
   {
       doMessage=true;
   }
   else
   {
     num = editGrayAsBlack.text.substr(numStart  );
        if ((isNaN(num) == true) | (num > 100) )
          {
            doMessage= true;
           }
           else
           {
               if (num == 100)
                {grayRGB = 0}
               else
                 {
                   grayRGB = Math.round(((100 - num)/100) *255)
                  }
            setSlidersRGB(grayRGB, grayRGB, grayRGB );
           }

  if (doMessage)
       {
        alert("Please Enter a Number in the Correct Form,\n\n e.g. Black!23 - 100 is the highest.");
         }
   }
}

function updateRGBfromHSV()
{
    rgbFromHsb = hsvToRgb(editHSBhue.text, editHSBsaturation.text, editHSBbrightness.text);

    setSlidersRGB(rgbFromHsb[0], rgbFromHsb[1], rgbFromHsb[2]);

}

function setSlidersRGB(Red, Green, Blue)
{
  //Global
    sliderMovedByScript = false;

  var colours = new Array(Red, Green, Blue);

    for (col in colours)
   {

      if ( isNaN(colours[col]) == true)
       { alert("Please type a Nummber in the Correct Range");
        }
      else
        {
            if (colours[col] *1 <= 1)
               {
                colours[col] = colours[col] * 255;
                }
            else
            {
                if ((colours[col] * 1) > 255)
                   {
                    alert("Please type a Nummber in the Correct Range");
                   }
             }
       if ( (colours[col] * 1 >= 0 ) & (colours[col] * 1 < 256))
       {
           eval("sliderRgb" + rgbNames[col] + ".value = " + colours[col].toString()  );

           //Global
           sliderMovedByScript = true;
       }
        }//   /End. Else
   } //   /End. for (col in arguments)

}


function getCurrentColour()
{
    // Presently in TeXWorks QT Scripting (06/2010) we have no xml tools so ...

    colourProperties.name="";
    colourProperties.colours.red = ""; colourProperties.colours.green = "";  colourProperties.colours.blue = "";

    if (currentColour.intRow != -1)
    { 
       tableFound = xmlUI.indexOf(currentColour.tableName);
           foundTable = xmlUI.substr(tableFound);
           findCell = "<item row=\""+ currentColour.intRow +"\" column=\""+ currentColour.intCol +"\">";     
           cellFound = foundTable.indexOf(findCell);
       
       foundCell = foundTable.substr(cellFound); 
           findString = "<string>";     
           stringFound = foundCell.indexOf(findString);
           
       foundString = foundCell.substr(stringFound + 8); 
           colourEnd =   foundString.indexOf("</string>");
       
       colourProperties.name =  foundString.substr(0,colourEnd);

       findCol = foundString.indexOf("<red>") +5;
       findColClose = foundString.indexOf("</red>");
       colourProperties.colours.red = foundString.substr(findCol,findColClose - findCol);

       findCol = foundString.indexOf("<green>") +7;
       findColClose = foundString.indexOf("</green>");
       colourProperties.colours.green = foundString.substr(findCol,findColClose - findCol);

       findCol = foundString.indexOf("<blue>") +6;
       findColClose = foundString.indexOf("</blue>");
       colourProperties.colours.blue = foundString.substr(findCol,findColClose - findCol);

     // alert(colourProperties.formRgb() );

     }

   // return colourProperties ;
	
  }	// /End.  function getCurrentColour()

function doThis(action)
{
 // helper function used with connect and disconnect functionality

    action ? doWhat = 'connect' : doWhat = 'disconnect';
    return doWhat;
}

function UIconnectSliders(booleanAction)
{
    //rgbNames Global

          for (col in rgbNames)
                 {
      eval("sliderRgb"+ rgbNames[col] +".valueChanged." + doThis(booleanAction) + "(sliderMoved)");
      //sliderReleased
           }
}

function  UIconnectColourTables(booleanAction)
{
     for (tabl in colourTables)
    {
        eval(colourTables[tabl] + ".cellClicked." + doThis(booleanAction) + "(handleColourTable)");
        eval(colourTables[tabl] + ".cellDoubleClicked." + doThis(booleanAction) + "(newfromNamedColour)");
     }
 }

/*

*From http://mjijackson.com/2008/02/rgb-to-hsl-and-rgb-to-hsv-color-model-conversion-algorithms-in-javascript

 * Converts an RGB color value to HSV. Conversion formula
 * adapted from http://en.wikipedia.org/wiki/HSV_color_space.
 * Assumes r, g, and b are contained in the set [0, 255] and
 * returns h, s, and v in the set [0, 1].
 *
 * @param   Number  r       The red color value
 * @param   Number  g       The green color value
 * @param   Number  b       The blue color value
 * @return  Array           The HSV representation
 */
function rgbToHsv(r, g, b){
    r = r/255, g = g/255, b = b/255;
    var max = Math.max(r, g, b), min = Math.min(r, g, b);
    var h, s, v = max;

    var d = max - min;
    s = max == 0 ? 0 : d / max;

    if(max == min){
        h = 0; // achromatic
    }else{
        switch(max){
            case r: h = (g - b) / d + (g < b ? 6 : 0); break;
            case g: h = (b - r) / d + 2; break;
            case b: h = (r - g) / d + 4; break;
        }
        h /= 6;
    }

    return [h, s, v];
}

/*

*From http://mjijackson.com/2008/02/rgb-to-hsl-and-rgb-to-hsv-color-model-conversion-algorithms-in-javascript

 * Converts an HSV color value to RGB. Conversion formula
 * adapted from http://en.wikipedia.org/wiki/HSV_color_space.
 * Assumes h, s, and v are contained in the set [0, 1] and
 * returns r, g, and b in the set [0, 255].
 *
 * @param   Number  h       The hue
 * @param   Number  s       The saturation
 * @param   Number  v       The value
 * @return  Array           The RGB representation
 */
function hsvToRgb(h, s, v){
    var r, g, b;

    var i = Math.floor(h * 6);
    var f = h * 6 - i;
    var p = v * (1 - s);
    var q = v * (1 - f * s);
    var t = v * (1 - (1 - f) * s);

   //Want to Adjust the following to allow for  xcolor v2.11 2007/01/21 Page 52, equation 72, correction of Smith's algorithm by Dr. Uwe Kern
    switch(i % 6){
        case 0: r = v, g = t, b = p; break;
        case 1: r = q, g = v, b = p; break;
        case 2: r = p, g = v, b = t; break;
        case 3: r = p, g = q, b = v; break;
        case 4: r = t, g = p, b = v; break;
        case 5: r = v, g = p, b = q; break;
    }

    return [r * 255, g * 255, b * 255];
}


  // Some what after, http://www.cadforum.cz/cadforum_en/qaID.asp?tip=5554

function cmykToRgb(){
var C=editCMYKcyan.text * 1;
var M=editCMYKmagenta.text * 1;
var Y=editCMYKyellow.text * 1;
var K=editCMYKblack.text * 1;
//alert(C + " " + M + " " + Y+ " " + K);

if (Math.max(C,M,Y,K) > 1)
{C=C/255.0;M=M/255.0;Y=Y/255.0;K=K/255.0;}

var R=Math.round((1-C)*(1-K)*255);
var B=Math.round((1-Y)*(1-K)*255);
var G=Math.round((1-M)*(1-K)*255);
//alert(R+ " " + G+ " " + B);
setSlidersRGB(R , G , B);

}



function Action(what)
{

}

function alert(text)
{
    TW.information(null, "TexWorks Message", text);
}


/////   Notes : -- \\\\\

/*
  JavaScropt refgerence http://www.crockford.com/javascript/private.html

*/

/*
From http://mjijackson.com/2008/02/rgb-to-hsl-and-rgb-to-hsv-color-model-conversion-algorithms-in-javascript

" Here is a set of additive color model conversion algorithms that I found published on Wikipedia

             http://en.wikipedia.org/wiki/HSL_color_space

" and have implemented in JavaScript. It was surprisingly difficult to find these actually implemented anywhere in compact, efficient, and bug-free code, so I wrote my own. These should be easily portable to other programming languages if desired. "

**
 * Converts an RGB color value to HSV. Conversion formula
 * adapted from http://en.wikipedia.org/wiki/HSV_color_space.
 * Assumes r, g, and b are contained in the set [0, 255] and
 * returns h, s, and v in the set [0, 1].
 *
 * @param   Number  r       The red color value
 * @param   Number  g       The green color value
 * @param   Number  b       The blue color value
 * @return  Array           The HSV representation
 *
function rgbToHsv(r, g, b){
    r = r/255, g = g/255, b = b/255;
    var max = Math.max(r, g, b), min = Math.min(r, g, b);
    var h, s, v = max;

    var d = max - min;
    s = max == 0 ? 0 : d / max;

    if(max == min){
        h = 0; // achromatic
    }else{
        switch(max){
            case r: h = (g - b) / d + (g < b ? 6 : 0); break;
            case g: h = (b - r) / d + 2; break;
            case b: h = (r - g) / d + 4; break;
        }
        h /= 6;
    }

    return [h, s, v];
}

**
 * Converts an HSV color value to RGB. Conversion formula
 * adapted from http://en.wikipedia.org/wiki/HSV_color_space.
 * Assumes h, s, and v are contained in the set [0, 1] and
 * returns r, g, and b in the set [0, 255].
 *
 * @param   Number  h       The hue
 * @param   Number  s       The saturation
 * @param   Number  v       The value
 * @return  Array           The RGB representation
 *
function hsvToRgb(h, s, v){
    var r, g, b;

    var i = Math.floor(h * 6);
    var f = h * 6 - i;
    var p = v * (1 - s);
    var q = v * (1 - f * s);
    var t = v * (1 - (1 - f) * s);

    switch(i % 6){
        case 0: r = v, g = t, b = p; break;
        case 1: r = q, g = v, b = p; break;
        case 2: r = p, g = v, b = t; break;
        case 3: r = p, g = q, b = v; break;
        case 4: r = t, g = p, b = v; break;
        case 5: r = v, g = p, b = q; break;
    }

    return [r * 255, g

*/

/*
  http://sci.tech-archive.net/Archive/sci.image.processing/2007-02/msg00120.html

      A better formula is:

Ctemp = 1 - R
Mtemp = 1 - G
Ytemp = 1 - Y
Ktemp = min(Ctemp. Mtemp, Ytemp)

C = min(1, max(0, Ctemp-Ktemp))
M = min(1, max(0, Mtemp-Ktemp))
Y = min(1, max(0, Ytemp-Ktemp))
K = min(1, max(0, Ktemp))

This is the default conversion used in PostScript.
(It is the PostScript Level 2 default conversion
from "DeviceRGB" to "DeviceCMYK".) In reality, a
PostScript printer will use more sophisticated
formulae tailored to its particular inks and
printing engine.

Regards,
Martin Leese


    http://www.php.net/manual/en/function.pdf-setcolor.php#42219
    _meto ALT+q web.de
    function rgb2cmyk($var1,$g=0,$b=0) {
   if(is_array($var1)) {
      $r = $var1['r'];
      $g = $var1['g'];
      $b = $var1['b'];
   }
   else $r=$var1;
   $cyan    = 255 - $r;
   $magenta = 255 - $g;
   $yellow  = 255 - $b;
   $black   = min($cyan, $magenta, $yellow);
   $cyan    = @(($cyan    - $black) / (255 - $black)) * 255;
   $magenta = @(($magenta - $black) / (255 - $black)) * 255;
   $yellow  = @(($yellow  - $black) / (255 - $black)) * 255;
   return array('c' => $cyan / 255,
                'm' => $magenta / 255,
                'y' => $yellow / 255,
                'k' => $black / 255);
}

  */




// http://stackoverflow.com/questions/294297/javascript-implementation-of-gzip
// http://jsolait.net/changeset/44/trunk
//http://en.wikipedia.org/wiki/LZW

// LZW-compress a string
function lzw_encode(s) {
    var dict = {};
    var data = (s + "").split("");
    var out = [];
    var currChar;
    var phrase = data[0];
    var code = 256;
    for (var i=1; i<data.length; i++) {
        currChar=data[i];
        if (dict[phrase + currChar] != null) {
            phrase += currChar;
        }
        else {
            out.push(phrase.length > 1 ? dict[phrase] : phrase.charCodeAt(0));
            dict[phrase + currChar] = code;
            code++;
            phrase=currChar;
        }
    }
    out.push(phrase.length > 1 ? dict[phrase] : phrase.charCodeAt(0));
    for (var i=0; i<out.length; i++) {
        out[i] = String.fromCharCode(out[i]);
    }
    return out.join("");
}

// Decompress an LZW-encoded string
function lzw_decode(s) {
    var dict = {};
    var data = (s + "").split("");
    var currChar = data[0];
    var oldPhrase = currChar;
    var out = [currChar];
    var code = 256;
    var phrase;
    for (var i=1; i<data.length; i++) {
        var currCode = data[i].charCodeAt(0);
        if (currCode < 256) {
            phrase = data[i];
        }
        else {
           phrase = dict[currCode] ? dict[currCode] : (oldPhrase + currChar);
        }
        out.push(phrase);
        currChar = phrase.charAt(0);
        dict[code] = oldPhrase + currChar;
        code++;
        oldPhrase = phrase;
    }
    return out.join("");
}

// /End. QtScript xcolor Dialogue
            //graceful exit  (possibly soon won't be required)
 null;
